#ifndef _DEVLOCK_H_
#define _DEVLOCK_H_

#include <unistd.h>
#include <stdio.h>
#include <errno.h>
#include <stdlib.h>
#include <dirent.h>
#include <string.h>
#include <sys/dirent.h>
#include <fcntl.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/cdefs.h>

#ifdef	__cplusplus
extern "C" {
#endif

#ifndef _PATH_LOCK
#  define LOCK_PATH	"/var/lock/"
#else
#  define LOCK_PATH	_PATH_LOCK
#endif
#ifndef _PATH_DEV
#  define DEV_PATH	"/dev/"
#else
#  define DEV_PATH	_PATH_DEV
#endif

/* Can be undefined if /dev/cua* not used */
	/* #undef HAS_CUA */
#define HAS_CUA

#ifdef HAS_CUA
#define TTYS "ttyS"
#define CUA  "cua"
#endif

/* 
 * Define MAJMIN if you want the LCK..<maj>.<min> type files
 * They are needed only if hard links are used in the /dev directory.
 */
	/* #undef MAJMIN */
#define MAJMIN

#if defined __linux__ && defined MAJMIN
#include <linux/kdev_t.h>
#else
#define MINORBITS	8
#define MINORMASK	((1<<MINORBITS) - 1)
#define MAJOR(dev)	((dev) >> MINORBITS)
#define MINOR(dev)	((dev) & MINORMASK)
#endif

	/*
	 * When MY_DEBUG is defined, debugging messages are issued by
	 * this library.  Otherwise, if the calling processes must define
	 * 'int debug'.  This makes this library less than portable.
	 */
#define MY_DEBUG

extern pid_t devlock   __P(( char * ));
extern pid_t devunlock __P(( char * ));
extern pid_t devrelock __P(( char *, pid_t ));
/* extern int ttywait __P( char * ); Later, maybe */

#ifdef	__cplusplus
};
#endif

#endif /* _DEVLOCK_H_ */
