#include <stdio.h>
#include "devlock.h"

void
usage() {
	fprintf( stderr, "sample -[l, u, r, d] <dev>\n" );
	fprintf( stderr, "Usage:\n\t-l lock <dev>\n\t-u unlock <dev>\n" );
	fprintf( stderr, "\t-r relock <dev>\n" );
	fprintf( stderr, "\t-dn debug\n" );
	exit( -1 );
}

int debug;


int
main( int argc, char *argv[] )
{
	int i, chld;
	char *p, *dev, ch;

	ch = '\0';
	for( i = argc - 1; i > 0; i-- ) {
		p = argv[i];
		if( *p == '-' ) {
			switch( *++p ) {
			case 'l': 
			case 'u': 
			case 'r': ch = *p; break;
			case 'd':
				debug = atoi(++p);
				break;
			default: usage(); break;
			}
		}
		else dev = p;
	}
	fprintf( stderr, "option %c, device %s\n", ch, dev );
	i = 0;
	switch( ch ) {
	case 'l':
		i = devlock( dev );
		break;
	case 'u':
		i = devunlock( dev );
		break;
	case 'r':
		devlock( dev );
		if(( chld = fork()) == 0 ) {
			sleep(5);
		}
		else {
			sleep( 1 );
			if(( i = devrelock( dev, chld )) < 0 ) {
				fprintf( stderr, "Relock failed in parent.\n" );
			}
		}
		break;
	default:
		fprintf( stderr, "No library function selected.\n" );
		break;
	}
	exit( i );
}
		 
